Mac (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.crypto

## Interface Mac

- All Known Implementing Classes:
    BlockCipherMac, CBCBlockCipherMac, CFBBlockCipherMac, CMac, CMacWithIV, GMac, GOST28147Mac, HMac, ISO9797Alg3Mac, OldHMac, Poly1305, SipHash, SkeinMac, SSL3Mac, VMPCMac

      public interface Mac

  The base interface for implementations of message authentication codes (MACs).

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `doFinal(byte[] out, int outOff)` Compute the final stage of the MAC writing the output to the out parameter.
    `java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the MAC implements.
    `int` | `getMacSize()` Return the block size for this MAC (in bytes).
    `void` | `init(CipherParameters params)` Initialise the MAC.
    `void` | `reset()` Reset the MAC.
    `void` | `update(byte in)` add a single byte to the mac for processing.
    `void` | `update(byte[] in, int inOff, int len)`

- - ### Method Detail

    - #### init

          void init(CipherParameters params)
                    throws java.lang.IllegalArgumentException

      Initialise the MAC.
      Parameters:
        `params` - the key and other data required by the MAC.
      Throws:
        `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

    - #### getAlgorithmName

          java.lang.String getAlgorithmName()

      Return the name of the algorithm the MAC implements.
      Returns:
        the name of the algorithm the MAC implements.

    - #### getMacSize

          int getMacSize()

      Return the block size for this MAC (in bytes).
      Returns:
        the block size for this MAC in bytes.

    - #### update

          void update(byte in)
                      throws java.lang.IllegalStateException

      add a single byte to the mac for processing.
      Parameters:
        `in` - the byte to be processed.
      Throws:
        `java.lang.IllegalStateException` - if the MAC is not initialised.

    - #### update

          void update(byte[] in,
                    int inOff,
                    int len)
                      throws DataLengthException,
                             java.lang.IllegalStateException

      Parameters:
        `in` - the array containing the input.
        `inOff` - the index in the array the data begins at.
        `len` - the length of the input starting at inOff.
      Throws:
        `java.lang.IllegalStateException` - if the MAC is not initialised.
        `DataLengthException` - if there isn't enough data in in.

    - #### doFinal

          int doFinal(byte[] out,
                    int outOff)
                      throws DataLengthException,
                             java.lang.IllegalStateException

      Compute the final stage of the MAC writing the output to the out parameter.

      doFinal leaves the MAC in the same state it was after the last init.

      Parameters:
        `out` - the array the MAC is to be output to.
        `outOff` - the offset into the out buffer the output is to start at.
      Throws:
        `DataLengthException` - if there isn't enough space in out.
        `java.lang.IllegalStateException` - if the MAC is not initialised.

    - #### reset

          void reset()

      Reset the MAC. At the end of resetting the MAC should be in the in the same state it was after the last init (if there was one).